/* eslint-disable @typescript-eslint/no-explicit-any */
import { h, createRef as gCreateRef, Component as gComponent } from "gridjs";
import { mount, unmount } from "svelte";
export class SvelteWrapper extends gComponent {
    ref = gCreateRef();
    instance = null;
    componentDidMount() {
        this.mountComponent();
    }
    componentDidUpdate(prevProps) {
        if (JSON.stringify(prevProps) !== JSON.stringify(this.props)) {
            this.destroyComponent();
            this.mountComponent();
        }
    }
    componentWillUnmount() {
        this.destroyComponent();
    }
    mountComponent() {
        const { component, props = {} } = this.props;
        if (this.ref.current) {
            this.instance = mount(component, {
                target: this.ref.current,
                props,
            });
        }
    }
    destroyComponent() {
        if (this.instance) {
            unmount(this.instance);
            this.instance = null;
        }
    }
    render() {
        return h("div", { ref: this.ref });
    }
}
